Index: /trunk/src/includes/admin/actions.php
===================================================================
--- /trunk/src/includes/admin/actions.php	(revision 6273)
+++ /trunk/src/includes/admin/actions.php	(revision 6274)
@@ -47,4 +47,5 @@
 add_action( 'current_screen',          'bbp_current_screen'                );
 add_action( 'wpmu_new_blog',           'bbp_new_site',               10, 6 );
+add_action( 'tool_box',                'bbp_admin_tool_box'                );
 
 // Hook on to admin_init
@@ -89,4 +90,5 @@
 add_action( 'load-tools_page_bbp-repair', 'bbp_admin_repair_handler' );
 add_action( 'load-tools_page_bbp-reset',  'bbp_admin_reset_handler'  );
+add_action( 'bbp_admin_tool_box',         'bbp_admin_tools_box'      );
 
 // Add sample permalink filter
@@ -266,4 +268,15 @@
 
 /**
+ * Dedicated action to output admin tools.php sections
+ *
+ * @since 2.6.0 bbPress (r6273)
+ *
+ * @uses do_action() Calls 'bbp_admin_tool_box'
+ */
+function bbp_admin_tool_box() {
+	do_action( 'bbp_admin_tool_box' );
+}
+
+/**
  * Dedicated action to hook into the current screen
  *
Index: /trunk/src/includes/admin/admin.php
===================================================================
--- /trunk/src/includes/admin/admin.php	(revision 6273)
+++ /trunk/src/includes/admin/admin.php	(revision 6274)
@@ -202,57 +202,45 @@
 		$hooks = array();
 
-		// These are later removed in admin_head
-		if ( current_user_can( 'bbp_tools_page' ) ) {
-			if ( current_user_can( 'bbp_tools_repair_page' ) ) {
-				$hooks[] = add_management_page(
-					__( 'Repair Forums', 'bbpress' ),
-					__( 'Forum Repair',  'bbpress' ),
-					$this->minimum_capability,
-					'bbp-repair',
-					'bbp_admin_repair'
-				);
+		// Get the tools pages
+		$tools = bbp_get_tools_admin_pages();
+
+		// Loop through tools and check
+		foreach ( $tools as $tool ) {
+
+			// Try to add the admin page
+			$page = add_management_page(
+				$tool['name'],
+				$tool['name'],
+				$tool['cap'],
+				$tool['page'],
+				$tool['func']
+			);
+
+			// Add page to hook if user can view it
+			if ( false !== $page ) {
+				$hooks[] = $page;
 			}
-
-			if ( current_user_can( 'bbp_tools_import_page' ) ) {
-				$hooks[] = add_management_page(
-					__( 'Import Forums', 'bbpress' ),
-					__( 'Forum Import',  'bbpress' ),
-					$this->minimum_capability,
-					'bbp-converter',
-					'bbp_converter_settings'
-				);
-			}
-
-			if ( current_user_can( 'bbp_tools_reset_page' ) ) {
-				$hooks[] = add_management_page(
-					__( 'Reset Forums', 'bbpress' ),
-					__( 'Forum Reset',  'bbpress' ),
-					$this->minimum_capability,
-					'bbp-reset',
-					'bbp_admin_reset'
-				);
-			}
-
-			// Fudge the highlighted subnav item when on a bbPress admin page
-			foreach ( $hooks as $hook ) {
-				add_action( "admin_head-$hook", 'bbp_tools_modify_menu_highlight' );
-			}
-
-			// Forums Tools Root
-			add_management_page(
-				__( 'Forums', 'bbpress' ),
-				__( 'Forums', 'bbpress' ),
-				$this->minimum_capability,
-				'bbp-repair',
-				'bbp_admin_repair'
-			);
-		}
+		}
+
+		// Fudge the highlighted subnav item when on a bbPress admin page
+		foreach ( $hooks as $hook ) {
+			add_action( "admin_head-{$hook}", 'bbp_tools_modify_menu_highlight' );
+		}
+
+		// Forums Tools Root
+		add_management_page(
+			__( 'Forums', 'bbpress' ),
+			__( 'Forums', 'bbpress' ),
+			'bbp_tools_page',
+			'bbp-repair',
+			'bbp_admin_repair'
+		);
 
 		// Are settings enabled?
-		if ( ! bbp_settings_integration() && current_user_can( 'bbp_settings_page' ) ) {
+		if ( ! bbp_settings_integration() ) {
 			add_options_page(
 				__( 'Forums',  'bbpress' ),
 				__( 'Forums',  'bbpress' ),
-				$this->minimum_capability,
+				'bbp_settings_page',
 				'bbpress',
 				'bbp_admin_settings'
@@ -267,5 +255,5 @@
 				__( 'Welcome to bbPress',  'bbpress' ),
 				__( 'Welcome to bbPress',  'bbpress' ),
-				$this->minimum_capability,
+				'bbp_about_page',
 				'bbp-about',
 				array( $this, 'about_screen' )
@@ -276,5 +264,5 @@
 				__( 'Welcome to bbPress',  'bbpress' ),
 				__( 'Welcome to bbPress',  'bbpress' ),
-				$this->minimum_capability,
+				'bbp_about_page',
 				'bbp-credits',
 				array( $this, 'credits_screen' )
Index: /trunk/src/includes/admin/functions.php
===================================================================
--- /trunk/src/includes/admin/functions.php	(revision 6273)
+++ /trunk/src/includes/admin/functions.php	(revision 6274)
@@ -278,24 +278,19 @@
 
 		// Setup core admin tabs
-		$tabs = apply_filters( 'bbp_tools_admin_tabs', array(
-			'0' => array(
-				'href' => get_admin_url( '', add_query_arg( array( 'page' => 'bbp-repair'    ), 'tools.php' ) ),
-				'name' => __( 'Repair Forums', 'bbpress' )
-			),
-			'1' => array(
-				'href' => get_admin_url( '', add_query_arg( array( 'page' => 'bbp-converter' ), 'tools.php' ) ),
-				'name' => __( 'Import Forums', 'bbpress' )
-			),
-			'2' => array(
-				'href' => get_admin_url( '', add_query_arg( array( 'page' => 'bbp-reset'     ), 'tools.php' ) ),
-				'name' => __( 'Reset Forums', 'bbpress' )
-			)
-		) );
+		$tabs = bbp_get_tools_admin_pages();
 
 		// Loop through tabs and build navigation
-		foreach ( array_values( $tabs ) as $tab_data ) {
-			$is_current = (bool) ( $tab_data['name'] == $active_tab );
+		foreach ( $tabs as $tab ) {
+
+			// Skip if user cannot visit page
+			if ( ! current_user_can( $tab['cap'] ) ) {
+				continue;
+			}
+
+			// Setup tab HTML
+			$is_current = (bool) ( $tab['name'] == $active_tab );
 			$tab_class  = $is_current ? $active_class : $idle_class;
-			$tabs_html .= '<a href="' . esc_url( $tab_data['href'] ) . '" class="' . esc_attr( $tab_class ) . '">' . esc_html( $tab_data['name'] ) . '</a>';
+			$tab_url    = get_admin_url( '', add_query_arg( array( 'page' => $tab['page'] ), 'tools.php' ) );
+			$tabs_html .= '<a href="' . esc_url( $tab_url ) . '" class="' . esc_attr( $tab_class ) . '">' . esc_html( $tab['name'] ) . '</a>';
 		}
 
@@ -303,2 +298,41 @@
 		return $tabs_html;
 	}
+
+/**
+ * Return possible tools pages
+ *
+ * @since 2.6.0 (r6273)
+ *
+ * @return array
+ */
+function bbp_get_tools_admin_pages() {
+	return apply_filters( 'bbp_tools_admin_tabs', array(
+		array(
+			'page' => 'bbp-repair',
+			'func' => 'bbp_admin_repair',
+			'cap'  => 'bbp_tools_repair_page',
+			'name' => esc_html__( 'Repair Forums', 'bbpress' ),
+
+			// Deprecated 2.6.0
+			'href' => get_admin_url( '', add_query_arg( array( 'page' => 'bbp-repair'    ), 'tools.php' ) )
+		),
+		array(
+			'page' => 'bbp-converter',
+			'func' => 'bbp_converter_settings',
+			'cap'  => 'bbp_tools_import_page',
+			'name' => esc_html__( 'Import Forums', 'bbpress' ),
+
+			// Deprecated 2.6.0
+			'href' => get_admin_url( '', add_query_arg( array( 'page' => 'bbp-converter' ), 'tools.php' ) )
+		),
+		array(
+			'page' => 'bbp-reset',
+			'func' => 'bbp_admin_reset',
+			'cap'  => 'bbp_tools_reset_page',
+			'name' => esc_html__( 'Reset Forums', 'bbpress' ),
+
+			// Deprecated 2.6.0
+			'href' => get_admin_url( '', add_query_arg( array( 'page' => 'bbp-reset'     ), 'tools.php' ) )
+		)
+	) );
+}
Index: /trunk/src/includes/admin/tools.php
===================================================================
--- /trunk/src/includes/admin/tools.php	(revision 6273)
+++ /trunk/src/includes/admin/tools.php	(revision 6274)
@@ -10,4 +10,46 @@
 // Exit if accessed directly
 defined( 'ABSPATH' ) || exit;
+
+/**
+ * Output a bbPress specific tools box
+ *
+ * @since 2.6.0 bbPress (r6273)
+ */
+function bbp_admin_tools_box() {
+
+	// Bail if user cannot access tools page
+	if ( ! current_user_can( 'bbp_tools_page' ) ) {
+		return;
+	}
+
+	// Get the tools pages
+	$links = array();
+	$tools = bbp_get_tools_admin_pages(); ?>
+
+	<div class="card">
+		<h3 class="title"><?php _e( 'Forums', 'bbpress' ) ?></h3>
+		<p><?php esc_html_e( 'bbPress provides the following tools to help you manage your forums:', 'bbpress' ); ?></p>
+
+		<?php
+
+		// Loop through tools and create links
+		foreach ( $tools as $tool ) {
+
+			// Skip if user cannot see this page
+			if ( ! current_user_can( $tool['cap'] ) ) {
+				continue;
+			}
+
+			// Add link to array
+			$links[] = sprintf( '<a href="%s">%s</a>', get_admin_url( '', add_query_arg( array( 'page' => $tool['page'] ), 'tools.php' ) ), $tool['name'] );
+		}
+
+		// Output links
+		echo '<p class="bbp-tools-links">' . implode( ' &middot; ', $links ) . '</p>';
+
+	?></div>
+
+<?php
+}
 
 /** Repair ********************************************************************/